`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2025/04/22 08:35:57
// Design Name: 
// Module Name: uart_ad7606c_ddr_parallel
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module uart_ad7606c_ddr_parallel(
    clk,    //ʱź
    reset_n,  //λź
    
    //LED
    led,
    //UART
    uart_rx,
    uart_tx,
    
    //AD7606
	ad7606_cs_n_o, 
	ad7606_rd_n_o, 
	ad7606_wr_n_o, 
	ad7606_busy_i, 
	ad7606_db_i,   
	ad7606_os_o,   
	ad7606_reset_o,
	ad7606_convst_o,
	
	//DDR
    // Inouts
    ddr3_dq,
    ddr3_dqs_n,
    ddr3_dqs_p,
    // Outputs
    ddr3_addr,
    ddr3_ba,
    ddr3_ras_n,
    ddr3_cas_n,
    ddr3_we_n,
    ddr3_reset_n,
    ddr3_ck_p,
    ddr3_ck_n,
    ddr3_cke,
    ddr3_cs_n,
    ddr3_dm,
    ddr3_odt	    
    );
    
    input        clk;
    input        reset_n;
    //LED
    output [1:0] led;
    //UART
    input        uart_rx;
    output       uart_tx;    
    //AD7606
    output wire        ad7606_cs_n_o;         
	output wire         ad7606_rd_n_o;         
	output wire         ad7606_wr_n_o;         
	input  wire        ad7606_busy_i;         
	inout  wire [15:0] ad7606_db_i;           
	output wire [2:0]  ad7606_os_o;           
	output wire         ad7606_reset_o;        
	output wire         ad7606_convst_o; 
    //DDR3 Interface
    // Inouts
    inout  [15:0]ddr3_dq;
    inout  [1:0] ddr3_dqs_n;
    inout  [1:0] ddr3_dqs_p;
    // Outputs
    output [13:0]ddr3_addr;
    output [2:0] ddr3_ba;
    output       ddr3_ras_n;
    output       ddr3_cas_n;
    output       ddr3_we_n;
    output       ddr3_reset_n;
    output [0:0] ddr3_ck_p;
    output [0:0] ddr3_ck_n;
    output [0:0] ddr3_cke;
    output [0:0] ddr3_cs_n;
    output [1:0] ddr3_dm;
    output [0:0] ddr3_odt;
    
    wire clk_100M;
    wire clk_200M;
    wire pll_locked;
    wire g_reset;
    
    
    wire [2:0] uart_baud_set; //
    wire [7:0] uart_rx_data; //Ҫ͵
    wire uart_rx_done; //ֽڷź
    
    wire [7:0]cmd_addr; //ĵַΣ00 ʼ01òͨţ03ò
    wire [31:0]cmd_data; //ݶΣҪõĲȻ߲ͨ
    wire cmdvalid;  //Чź    
    
    wire [7:0]rx_data;
    wire rx_done;
    
    wire [7:0]ChannelSel;
    wire [31:0]DataNum;
    wire [31:0]ADC_soft_modle;
    wire [31:0] ADC_Speed_Set;
    wire RestartReq;
    
    wire ddr3_init_done;   //DDR3ʼɱ־ź
    
    wire wrfifo_clr;
    wire wrfifo_full;
    wire wrfifo_wren;
    
    wire rdfifo_clr;
    wire rdfifo_empty;
    wire rdfifo_rden;
    wire [15:0]rdfifo_dout;
    wire [11:0]ad_out_s;   
    wire ddr3_rst_n;
    
    wire uart_send_en;
    wire [7:0]uart_tx_data;
    wire uart_tx_done;
    
    wire [7:0]adc_data_flag;
    wire [15:0]adc_data_mult_ch; 
    
    wire ad_sample_en; //ʹADʼ־ź
       
    assign ddr3_rst_n = pll_locked;
     //led[0] ໷źΪߣ˵໷ʱ
    //led[1] DDR3ʼɱʶźţΪߣ˵DDR3Ѿɳʼ
    assign led = {ddr3_init_done,pll_locked};
        
    assign g_reset = ~pll_locked;
    //PLL:200MʱӸDDRʹã100MʱӸģʹ
    clk_wiz_0 pll
   (
    // Clock out ports
    .clk_out1(clk_100M),     // output clk_out1
    .clk_out2(clk_200M),     // output clk_out2
    // Status and control signals
    .resetn(reset_n), // input resetn
    .locked(pll_locked),       // output locked
   // Clock in ports
    .clk_in1(clk));      // input clk_in1
    
    //ڽģ飺
     uart_byte_rx uart_byte_rx(
        .clk       (clk_100M      ),
        .reset     (g_reset      ),
        .baud_set  (4),
        .uart_rx   (uart_rx      ),
        .data_byte (uart_rx_data ),
        .rx_done   (uart_rx_done )
    );
    
    //ģ飺ڽյתɶӦź
    uart_cmd uart_cmd_inst(
        .Clk      (clk_100M   ),
        .Reset_n  (~g_reset     ),
        .rx_data  (uart_rx_data ),
        .rx_done  (uart_rx_done ),
        .address  (cmd_addr     ),
        .data     (cmd_data     ),
        .cmdvalid (cmdvalid     )
    );
    
    //תģ飺תADCصź
    cmd_ctrl cmd_ctrl(
       .Clk(clk_100M),
       .Reset_n(g_reset),
       .cmd_data(cmd_data),
       .cmd_addr(cmd_addr),
       .cmdvalid(cmdvalid),
       .RestartReq(RestartReq),
       .ChannelSel(ChannelSel),
       .DataNum(DataNum),
       .ADC_soft_modle(ADC_soft_modle),
       .ADC_Speed_Set(ADC_Speed_Set)
     );
    
    //AD7606ģ
    ad7606C_soft_driver ad7606C_soft_driver(
        .Clk(clk_100M),
        .Reset_n(~g_reset),
        .Go(ad_sample_en),
        .Speed_Set(ADC_Speed_Set),
        .ADC_soft_modle(ADC_soft_modle),
        .RestartReq(RestartReq),
        .DataNum(DataNum),
        .Conv_Done(),
        .ad7606_cs_n_o(ad7606_cs_n_o), 
        .ad7606_rd_n_o(ad7606_rd_n_o), 
        .ad7606_wr_n_o(ad7606_wr_n_o), 
        .ad7606_busy_i(ad7606_busy_i), 
        .ad7606_db_i(ad7606_db_i), 
        .ad7606_os_o(ad7606_os_o), 
        .ad7606_reset_o(ad7606_reset_o), 
        .ad7606_convst_o(ad7606_convst_o), 
		.data_flag(adc_data_flag),
		.data_mult_ch(adc_data_mult_ch),
        .data1(),
        .data2(), 
        .data3(), 
        .data4(), 
        .data5(), 
        .data6(), 
        .data7(), 
        .data8()
    );	    
    //״̬ź
    state_ctrl state_ctrl(
        .clk(clk_100M),
        .reset(g_reset),
        
        .DataNum(DataNum),    //βɼݸ
        .RestartReq(RestartReq),       //ʼź
        .ChannelSel(ChannelSel),  //Ҫͨѡ  ÿһλӦһͨĿ
        
        .adc_data_flag(adc_data_flag),      //ÿͨĽ֮󣬾Ͳһ Flag źţ֪ͨⲿȡ
        
        .ddr3_init_done(ddr3_init_done),
        .uart_tx_done(uart_tx_done),
        .rdfifo_empty(rdfifo_empty),
        .rdfifo_dout(rdfifo_dout),
        .wrfifo_full(wrfifo_full),	
        //wrfifo_clr֤wrfifoźŵЧ
        .wrfifo_clr(wrfifo_clr),
        .ad_sample_en(ad_sample_en),
        
        .wrfifo_wren(wrfifo_wren),
        .rdfifo_clr(rdfifo_clr),
        .rdfifo_rden(rdfifo_rden),
        .uart_send_en(uart_send_en),
        .uart_tx_data(uart_tx_data)	
);
    
        
    //DDR3˫˿ģ
    ddr3_ctrl_2port #(
    .FIFO_DW                            (16                        ),
    .WR_BYTE_ADDR_BEGIN                 (0                         ),
    .WR_BYTE_ADDR_END                   (256*1024*1024-1           ),
    .RD_BYTE_ADDR_BEGIN                 (0                         ),
    .RD_BYTE_ADDR_END                   (256*1024*1024-1           ),
    .FIFO_ADDR_DEPTH                    (64                        ) 
  )
  ddr3_ctrl_2port(
    .ddr3_clk200m  (clk_200M   ),
    .ddr3_rst_n    (ddr3_rst_n    ),
    .ddr3_init_done(ddr3_init_done),
    .wrfifo_clr    (wrfifo_clr    ),
    .wrfifo_clk    (clk_100M    ),
    .wrfifo_wren   ((adc_data_flag & ChannelSel)  && ad_sample_en),
    .wrfifo_din    (adc_data_mult_ch),
    .wrfifo_full   (wrfifo_full   ),
    .wrfifo_wr_cnt (              ),
    //rd_fifo Interface
    .rdfifo_clr    (rdfifo_clr    ),
    .rdfifo_clk    (clk_100M    ),
    .rdfifo_rden   (rdfifo_rden   ),
    .rdfifo_dout   (rdfifo_dout   ),
    .rdfifo_empty  (rdfifo_empty  ),
    .rdfifo_rd_cnt (              ),
    // Inouts
    .ddr3_dq       (ddr3_dq       ),
    .ddr3_dqs_n    (ddr3_dqs_n    ),
    .ddr3_dqs_p    (ddr3_dqs_p    ),
    // Outputs      
    .ddr3_addr     (ddr3_addr     ),
    .ddr3_ba       (ddr3_ba       ),
    .ddr3_ras_n    (ddr3_ras_n    ),
    .ddr3_cas_n    (ddr3_cas_n    ),
    .ddr3_we_n     (ddr3_we_n     ),
    .ddr3_reset_n  (ddr3_reset_n  ),
    .ddr3_ck_p     (ddr3_ck_p     ),
    .ddr3_ck_n     (ddr3_ck_n     ),
    .ddr3_cke      (ddr3_cke      ),
    .ddr3_cs_n     (ddr3_cs_n     ),
    .ddr3_dm       (ddr3_dm       ),
    .ddr3_odt      (ddr3_odt      )
   );
   
    //ڷģ
    uart_byte_tx uart_byte_tx(
        .clk       (clk_100M   ),//50Mʱ,
        .reset     (g_reset      ),//ģ鸴λ,
        .data_byte (uart_tx_data ),//8bit,
        .send_en   (uart_send_en ),//ʹ,
        .baud_set  (4),//ڲ
        .uart_tx   (uart_tx      ),//Rs232ź,
        .tx_done   (uart_tx_done )//һηɱ־,
    );
endmodule